/*$Id: d_res.cc,v 13.32 1999/04/25 07:12:45 al Exp $ -*- C++ -*-
 * functions for resistor.
 * x = amps, y.f0 = volts, ev = y.f1 = ohms
 */
#include "d_res.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_RESISTANCE::expand();
// 	bool	DEV_RESISTANCE::dotr();
// 	void	DEV_RESISTANCE::doac();
/*--------------------------------------------------------------------------*/
CARD& DEV_RESISTANCE::expand()
{
  if (value() == 0.){
    error(bPICKY, "%s: short circuit\n", printlabel());
    y0.f1 = OPT::shortckt;
  }else{
    y0.f1 = value();
  }
  y0.f0 = LINEAR;
  m0.f1 = 1./y0.f1;
  m0.c0 = 0.;
  ev    = value();
  acg   = m0.f1;
  assert(loss == 0.);
  setconstant(!has_tr_eval());
  return *this;
}
/*--------------------------------------------------------------------------*/
bool DEV_RESISTANCE::dotr()
{
  assert(!isbypassed());
  if (has_tr_eval()){
    m0.x = volts_limited(n[OUT1],n[OUT2]);
    y0.x = m0.c0 + m0.f1 * m0.x;
    tr_eval();
    if (y0.f1 == 0.){
      untested();
      error(bPICKY, "%s: short circuit\n", printlabel());
      y0.f1 = OPT::shortckt;
    }
    store_values();
    SIM::loadq.push(this);
    m0.f1 = 1./y0.f1;
    m0.c0 = y0.x - y0.f0 / y0.f1;
  }else{
    untested();
    assert(conchk(m0.f1, 1./y0.f1, OPT::abstol));
    assert(m0.c0 == 0.);
    assert(y1 == y0);
    assert(converged());
  }
  return converged();
}
/*--------------------------------------------------------------------------*/
CARD& DEV_RESISTANCE::doac()
{
  if (has_ac_eval()){
    double dcvolts = n[OUT1].vdc() - n[OUT2].vdc();
    acbias = m0.c0 + m0.f1*dcvolts;
    ac_eval();
    if (ev == 0.){
      untested();
      error(bPICKY, "%s: short circuit\n", printlabel());
      ev = OPT::shortckt;
    }
    acg = 1. / ev;
  }else if (has_tr_eval()){
    untested();
    ev  = y0.f1;
    acg = 1. / y0.f1;
  }else{
    //assert(acg == 1./y0.f1);
  }
  return acload_passive();
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
