/*$Id: e_bm_poly.cc,v 13.39 1999/05/14 08:53:21 al Exp $ -*- C++ -*-
 * HSPICE compatible POLY
 */
#include "ap.h"
#include "e_bm.h"
/*--------------------------------------------------------------------------*/
//		EVAL_BM_POLY::setdefault()
//	void	EVAL_BM_POLY::parse(CS& cmd);
// 	void	EVAL_BM_POLY::print(int)const;
/*--------------------------------------------------------------------------*/
EVAL_BM_POLY& EVAL_BM_POLY::setdefault()
{
  scale = 1.;
  tc1 = 0.;
  tc2 = 0.;
  ic = 0.;
  min = -BIGBIG;
  max = BIGBIG;
  abs = false;
  hasoptions = false;
  return *this;
}
/*--------------------------------------------------------------------------*/
EVAL_BM_POLY::EVAL_BM_POLY(const EVAL_BM_POLY& p)
  :EVAL_BM_BASE(p),
   max(p.max),
   min(p.min),
   abs(p.abs),
   c(p.c)
{
  untested();
}
/*--------------------------------------------------------------------------*/
void EVAL_BM_POLY::parse(CS& cmd)
{
  cmd.stuck();
  do{
    double value=NOT_VALID;
    cmd >> value;
    if (cmd.gotit()){
      c.push_back(value);
    }else{
      cmd.get("Scale",  &scale);
      cmd.get("TNOM",	&tnom, mOFFSET, -ABS_ZERO);
      cmd.get("TC1",    &tc1);
      cmd.get("TC2",    &tc2);
      cmd.get("IC",     &ic);
      cmd.get("MIn",	&min);
      cmd.get("MAx",    &max);
      cmd.pmatch("Abs") &&
	( ::set(cmd, "0", &abs, false)
	||::set(cmd, "1", &abs, true)
	||(abs = true));
      hasoptions = true;
    }
  }while (cmd.more() && !cmd.stuck());
  cmd.check(bWARNING);
  {if (tnom == NOT_INPUT){
    tnom = OPT::tnom;
  }else{
    untested();
  }}
}
/*--------------------------------------------------------------------------*/
void EVAL_BM_POLY::print(OMSTREAM where)const
{
  if (hasoptions){
    where << "  scale="	<< scale
	  << "  tnom="	<< tnom+ABS_ZERO
	  << "  tc1="	<< tc1
	  << "  tc2="	<< tc2
	  << "  ic="	<< ic
	  << "  min="	<< min
	  << "  max="	<< max
	  << "  abs="	<< abs;
  }
  for (std::vector<double>::const_iterator
	 p = c.begin();  p != c.end();  ++p){
    where << "  " << *p;
  }
}
/*--------------------------------------------------------------------------*/
void EVAL_BM_POLY::tr_eval(COMPONENT* brh)const
{
  assert(tnom > 0);
  double tempdiff = SIM::temp - tnom;
  double realscale = scale * (1 + tc1 * tempdiff + tc2 * tempdiff * tempdiff);
  double x = brh->y0.x;
  double f0 = 0.;
  double f1 = 0.;
  for (int i=c.size()-1; i>0; --i){
    f0 += c[i];
    f0 *= x;
    f1 *= x;
    f1 += c[i]*i;
  }
  f0 += c[0];

  {if (abs && f0 < 0){
    untested();
    f0 = -f0;
    f1 = -f1;
  }else{
    // leave it as is
  }}
  {if (f0 > max){
    f0 = max;
    f1 = 0;
  }else if (f0 < min){
    f0 = min;
    f1 = 0;
  }else{
    // leave it as is
  }}
    
  brh->y0 = fpoly1_t(x, f0, f1);
  brh->y0 *= realscale;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
