/*$Id: u_probe.h,v 13.40 1999/05/19 08:40:21 al Exp $ -*- C++ -*-
 * single probe item
 */
#ifndef U_PROBE_H
#define U_PROBE_H
#include "md.h"
#include "l_compar.h" // inorder
/*--------------------------------------------------------------------------*/
class CKT_BASE;
/*--------------------------------------------------------------------------*/
class PROBE {
private:
  char	    _what[LABELEN+1];    
  int	    _node;
  CKT_BASE* _brh;
  double    _lo,_hi;
public:
  explicit  PROBE(const char *what, int node, double lo=0, double hi=0);
  explicit  PROBE(const char *what, CKT_BASE *brh, double lo=0, double hi=0);
	    PROBE(const PROBE& p);
	    ~PROBE()				{detach();}

  void	    set_limit(double lo,double hi)	{_lo = lo; _hi = hi;}
  PROBE&    detach();
  PROBE&    operator=(const PROBE& p);

  bool      operator<(const PROBE&)const;
  bool	    operator==(const PROBE&)const;
  bool	    operator!=(const PROBE& p)const	{return !(*this == p);}
  
  char*	    label()const;
  double    value()const;
  CKT_BASE* object()const	{return _brh;}
  double    lo()const		{return _lo;}
  double    hi()const		{return _hi;}
  double    range()const	{return hi()-lo();}
  bool	    inrange()const	{return inorder(lo(),value(),hi());}
private:
  double    probe_node()const;
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
